/***************************************************************************
                          eztranslation  -  description
                             -------------------
    begin                : Oct. 17, 2004
    copyright            : (C) 2005 by Allen
    email                : bon_ami_@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   Explicit Distribution Limitation                                      *
 *   This rule overrides others below.                                     *
 *   This program may not be modified or used by, or, if possible,         *
 *   redistributed to people described as below,                           *
 *   1.Japanese who hold hostility against Chinese.                        *
 *   2.or, those who discriminate against people based solely on race,     *
 *     gender or sexual orientation.                                       *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const char * const DEFFL = "eztranslation.def";
struct dictchn
{
	char *e;
	char *c;
	struct dictchn *n;
} *dict = NULL;
unsigned int dictvol;

/*
return values:	length of the dictionary; -1: already opened; -2: definition file opening error;
			-3: memory failure.
*/
int eztranslationopen(void)
{
	const unsigned MAXLN = 256;

	char se[MAXLN];
	char *sc;
	FILE *fp;
	struct dictchn *chnndc = NULL, *chnndn;
	int result = 0, j;
	unsigned char i = 0;

	if (dict != NULL)
		return -1;

	if (NULL != (fp = fopen(DEFFL, "r")))
	{
		printf("opening dictionary (counting words)           ");
		while ((NULL != fgets(se, MAXLN, fp)) && (i != 100))
		{
			if (NULL == (sc = strchr(se, '\t')))
				continue;
			if ('\n' == se[strlen(se) - 1])
				se[strlen(se) - 1] = '\0';
			*sc = '\0';
			sc++;
			j = result / 2 + 1;
			if (0 == (j / 10))
				printf("\b%d", j);
			else
				if (0 == (j / 100))
					printf("\b\b%d", j);
				else
					if (0 == (j / 1000))
						printf("\b\b\b%d", j);
					else
						if (0 == (j / 10000))
							printf("\b\b\b\b%d", j);
						else
							if (0 == (j / 100000))
								printf("\b\b\b\b\b%d", j);
							else
								/*	too many to display	*/
								if (0 == result % 2)
									printf("\\\b");
								else
									printf("/\b");
			for (i = 0; i < 2; i++)
			{
				if (NULL == (chnndn = calloc(1, sizeof(struct dictchn))))
				{
					i = 100;
					break;
				}
				chnndn->n = NULL;
				if ((NULL == (chnndn->e = strdup(se))) || (NULL == (chnndn->c = strdup(sc))))
				{
					i = 100;
					break;
				}
				if (NULL == dict)
					dict = chnndn;
				else
				{
					switch (i)
					{
						case 1:
							/*	change 1st. letter to uppercase	*/
							*chnndn->e -= 32;
							break;
					}
					chnndc->n = chnndn;
				}
				chnndc = chnndn;
				result++;
			}
		}
		fclose(fp);
		if (100 == i)
		{
			for (chnndc = dict; chnndc != NULL; chnndc = chnndn)
			{
				chnndn = chnndc->n;
				free(chnndc->c);
				free(chnndc->e);
				free(chnndc);
			}
			return -3;
		}
		printf("\r                                               \r");
	}
	else
		return -2;

	return dictvol = result;
}

#define LTR(C) (((C > 64) && (C < 89)) || ((C > 96) && (C < 121)))

#define RLSELE for (ele = hd; ele != NULL; ele = eb)\
	{\
		eb = ele->n;\
		free(ele->s);\
		free(ele);\
	}\
	return -3;

/*
return values:	characters translated out; -1: none; -2: dictionary not opened yet; -3: memory failure.
*/
int eztranslationtran(const char *buf, char **res)
{
	struct dictchn *chnnd = dict;
	struct elmnt
	{
		char *s;
		struct elmnt *n;
	} *hd;
	struct elmnt *ele, *eb, *et;
	unsigned i, l, h;
	char *st, *sp;

	if ((NULL == buf) || (NULL == dict))
		return -2;
	if (NULL == (hd = malloc(sizeof(struct elmnt))))
		return -3;
	hd->n = NULL;
	if (NULL == (hd->s = strdup(buf)))
	{
		free(hd);
		return -3;
	}
	printf("translating       ");
	for (i = 0; i < dictvol; i++)
	{
		ele = hd;
		if ((i * 100 / dictvol) < 10)
			printf("\b\b%d%%", i * 100 / dictvol);
		else
			printf("\b\b\b%d%%", i * 100 / dictvol);
		do
		{
			st = ele->s;
			while (NULL != (sp = strstr(st, chnnd->e)))
			{
				l = strlen(chnnd->e);
				if (((sp != st) && LTR(*(sp-1))) || ((sp[l] != '\0')
							&& LTR(sp[l])))
					st = &sp[l];
				else
					if (l >= (h = strlen(chnnd->c)))
					{
						strncpy(sp, chnnd->c, h);
						strcpy(sp + h, sp + l);
						st += h;
					}
					else
					{
						if (NULL == (eb = calloc(1, sizeof(struct elmnt))))
						{
							ele = NULL;
							break;
						}
						if (NULL == (et = calloc(1, sizeof(struct elmnt))))
						{
							ele = NULL;
							free(eb);
							break;
						}
						if (NULL == (eb->s = strdup(chnnd->c)))
						{
							ele = NULL;
							free(eb);
							free(et);
							break;
						}
						if (NULL == (et->s = strdup(sp + l)))
						{
							ele = NULL;
							free(eb->s);
							free(eb);
							free(et);
							break;
						}
						*sp = '\0';
						et->n = ele->n;
						ele->n = eb;
						ele = eb->n = et;
						st = et->s;
					}
			}
			if (ele != NULL)	/*	if not memory failure	*/
				ele = ele->n;
		} while (ele != NULL);
		if (NULL == chnnd)	/*	memory failure	*/
		{
			RLSELE
		}
		chnnd = chnnd->n;
	}
	printf("\b\b\b100%%");
	i = 0;
	ele = hd;
	do
	{
		printf(".");
		i += strlen(ele->s);
		ele = ele->n;
	} while (ele != NULL);
	if (i < 1)
		return -1;
	if (NULL == (*res = malloc(i + 1)))
	{
		RLSELE
	}
	strcpy(*res, "");
	ele = hd;
	while (ele != NULL)
	{
		printf("\b \b");
		eb = ele;
		strcat(*res, ele->s);
		ele = ele->n;
		free(eb->s);
		free(eb);
	}
	printf("\r                   \r");

	return i;
}

/*
remember to call this!
*/
void eztranslationclose(void)
{
	struct dictchn *chnnd = dict, *chnndt;

	while (chnnd != NULL)
	{
		free(chnnd->c);
		free(chnnd->e);
		chnndt = chnnd;
		chnnd = chnnd->n;
		free(chnndt);
	}
	dict = NULL;
}
